<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="page_ble_section_indastry_standards" kind="group">
    <compoundname>page_ble_section_indastry_standards</compoundname>
    <title>Industry Standards</title>
    <detaileddescription>

<para><heading level="1">Bluetooth Qualification</heading></para>
<para>BLE solutions provided by Cypress are listed on the Bluetooth SIG website as certified solutions. The qualification is modular, allowing greater flexibility to customers. The following is the list of Qualified Design IDs (QD ID) and Declaration IDs. </para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>This section describes the MISRA-C:2004 compliance and deviations for the PSoC 6 BLE Middleware.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/ Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;No reliance shall be placed on undefined or unspecified behaviour. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;This specific behavior is explicitly covered in rule 5.1.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;5.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Identifiers (internal and external) shall not rely on the significance of more than 31 characters. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;This rule applies to ISO:C90 standard. PDL conforms to ISO:C99 that does not require this limitation.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;5.6 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;No identifier in one name space should have the same spelling as an identifier in another name space, with the exception of structure member and union member names. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The internal structure has field with the same name as function of standard library. This is safe as any assignment to the function from standard library will be discovered at design time.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;9.3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;In an enumerator list, the '=' construct shall not be used to explicitly initialise members other than the first, unless all items are explicitly initialised. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;There are enumerator lists which depend on configurations (e.g. cy_en_ble_srvi_t) and require to use the '=' construct for calculating the instance count for the multi-instances services, such as HIDS, BAS or CUSTOM  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;10.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The value of an expression of integer type shall not be implicitly converted to a different underlying type under some circumstances. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;An operand of essentially enum type is being converted to unsigned type as a result of an arithmetic or conditional operation. The conversion does not have any unintended effect.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;10.3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A composite integer expression is being cast to a wider type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Use of a Cypress defined macro to access memory-mapped objects. Calculating the clock parameters.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cast should not be performed between a pointer to object type and a different pointer to object type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cast involving pointers is conducted with caution that the pointers are correctly aligned for the type of object being pointed to.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.5 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cast shall not be performed that removes any const or volatile qualification from the type addressed by a pointer. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The const or volatile qualification is lost during pointer cast before passing to the stack functions.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;13.7 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Boolean operations whose results are invariant shall not be permitted. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A Boolean operator can yield a result that can be proven to be always "true" or always "false" in some specific configurations because of generalized implementation approach.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;16.7 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The object addressed by the pointer parameter is not modified and so the pointer could be of type 'pointer to const'. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The 'base' and 'content' parameters in Cy_BLE_DeepSleepCallback function are not used by BLE but callback type is universal for all drivers.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;18.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Unions shall not be used. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The use of deviations is acceptable for packing and unpacking of data, for example when sending and receiving messages, and implementing variant records provided that the variants are differentiated by a common field.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;19.16 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Preprocessing directives shall be syntactically meaningful even when excluded by the preprocessor. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The reason for this deviation is that not standard directive "warning" is used. This directive is works on all compilers which PDL supports (e.g. GCC, IAR, MDK).   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>